	/* Standard 'C' Includes */
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <time.h>

	/* User Defined Includes */
#include "genutil.h"
#include "fileutil.h"
#include "keyasm.h"
#include "keybrd.h"
#include "mouse.h"
#include "buttons.h"
#include "util.h"

	/* Program Specific Includes */
#include "scrlbar.h"
#include "listbox.h"
#include "filelist.h"


	/* Save states for the initial directory QEdit starts off in */
char orig_directory [MAX_STRING_LENGTH+1];
int orig_drive;


/*========== Main routine for the load/save boxes =========================*/
boolean file_dialogue(char far *filename, char *path, const char far *title, const char far *button, const char *orig_filter) {
  BUTTON_ARRAY dialogue_buttons;	/* The Load/Save/Cancel Buttons */
  const int sy = get_screenheight();
  const int filename_x = 40 - DIALOGUE_WIDTH/2 + 3;       /* The filename-box dimensions */
  const int filename_y = (sy - DIALOGUE_HEIGHT)/2 + 3;
  const int filename_width = 20;

  char filter[MAX_STRING_LENGTH + 1] = "*.*";	//Holds current file filter...
  CAPTURE_TEXT cap_text;	/* Holds saved screen background to be reset at end */
  char buffer[MAX_STRING_LENGTH + 1];  //Temp string...contains filename

  int orig_text_color, orig_back_color;	/* Save initial colors of screen */
  int i;	/* Loop counter */
  int current_box = 0, event;
  int double_click_item = -1;
  clock_t double_click_time = -1;
  boolean do_double_click = FALSE;

  LIST_BOX file_box ( 40 - DIALOGUE_WIDTH/2 + 3, 6,
		      17, 13, DIAGWIN_TEXT_COLOR, DIAGWIN_BACK_COLOR,
		      DIAGWIN_BOLD_TEXT_COLOR, DIAGWIN_BOLD_BACK_COLOR );
  LIST_BOX drive_box ( 40 -DIALOGUE_WIDTH/2 + 25, 14,
			8, 5,DIAGWIN_TEXT_COLOR, DIAGWIN_BACK_COLOR,
			DIAGWIN_BOLD_TEXT_COLOR, DIAGWIN_BOLD_BACK_COLOR );

  boolean done = FALSE, cancel = FALSE;
  boolean redraw = TRUE;

	/* Create the two required buttons for the dialogue window */
  dialogue_buttons.new_button(40 - DIALOGUE_WIDTH/2 + 28, 25 - DIALOGUE_HEIGHT/2 + 3, (25 - DIALOGUE_HEIGHT)/2 + 3, 10, 3, button);
  dialogue_buttons.new_button(40 - DIALOGUE_WIDTH/2 + 28, 25 - DIALOGUE_HEIGHT/2 + 8, (25 - DIALOGUE_HEIGHT)/2 + 8, 10, 3, "Cancel");

	/* Since we can't have this in above declaration */
  file_box.y += (sy - DIALOGUE_HEIGHT)/2;
  file_box.scroll_bar.y50 = file_box.scroll_bar.y = file_box.y;
  drive_box.y += (sy - DIALOGUE_HEIGHT)/2;
  drive_box.scroll_bar.y50 = drive_box.scroll_bar.y = drive_box.y;

	/* Set the initial value for the filename filter */
  if (orig_filter != NULL) strcpy (filter, orig_filter);

	/* Save background */
  get_screen (DIALOGUE_WIDTH, DIALOGUE_HEIGHT, &cap_text);

  strcpy (buffer, filename);  /* Set string to initially the inputed filename */

	/* Save colors to reset later */
  orig_text_color = get_text_color();
  orig_back_color = get_back_color();

	/* No specified initial dir? Use current */
  if (strlen (path) == 0) {
    if (getcwd (path, MAX_STRING_LENGTH) == NULL)
      error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");
   }
  else {	/* Goto initial 'saved' directory */
    setdisk (*path - 'A');
    chdir (path);
   }


  hide_mouse();
  textcolor(BIGWIN_BORD_COLOR);   /* Draw the main file-frame and text */
  textbackground(BIGWIN_BACK_COLOR);
  draw_textbox_center(DIALOGUE_WIDTH, DIALOGUE_HEIGHT, title, BLUE);
  textcolor(YELLOW);
  gotoxy (filename_x + 1, filename_y - 1);
  cprintf ("F");
  textcolor (BLUE);
  cprintf ("ilename");
  gotoxy (filename_x + 1, filename_y + 2);
  textcolor (YELLOW);
  cprintf ("F");
  textcolor (BLUE);
  cprintf ("iles");
  gotoxy (40 - DIALOGUE_WIDTH/2 + 26, (sy - DIALOGUE_HEIGHT)/2 + 13);
  textcolor(YELLOW);
  cprintf ("D");
  textcolor(BLUE);
  cprintf ("rives");
  dialogue_buttons.draw ();
  show_mouse();

	/* Any error getting the drive listing? */
  if (!get_drivelist (&drive_box)) {
    error_box ("ERROR Reading Drives", "Could Not Retrieve Drive List!");
    return(FALSE);
   }

	/* Get the initial list of files */
  get_filelist (&file_box, filter);

  do { /* Main file-box loop */
    if (redraw) {  /* Redraw all the boxes in the main file-box */
      redraw = FALSE;
      hide_mouse();

		/* Draw the two list boxes */
      file_box.draw ();
      drive_box.draw ();

		/* Print path/filter status line */
      gotoxy (40 - DIALOGUE_WIDTH/2 + 2, (sy + DIALOGUE_HEIGHT)/2 - 1);
      textcolor (LIGHTBLUE);
      textbackground (LIGHTGRAY);

      if (path[strlen(path)-1] != '\\')
	cprintf (" %s\\%-*s ", path, DIALOGUE_WIDTH - strlen(path) - 5, filter);
      else
	cprintf (" %s%-*s ", path, DIALOGUE_WIDTH - strlen(path) - 4, filter);

		/* If we're in the file list, change filename to match */
      if (current_box == 1) file_box.get_name (buffer);
      buffer[12] = 0;

		/*  Print filename box */
      textcolor(LIGHTGRAY);
      textbackground(BLACK);
      gotoxy(filename_x, filename_y);
      cprintf (" %-*s ", filename_width, buffer);

		//Display cursor only if in filename input box
      if (current_box == 0) {
	gotoxy (filename_x + strlen(buffer) + 1, filename_y);
       _setcursortype(_NORMALCURSOR);
       }
      else
	_setcursortype(_NOCURSOR);

      show_mouse();
     } //End of redraw

    event = get_mouse_event (LEFT_BUTTON) | get_mouse_event (RIGHT_BUTTON);

    if ((i = dialogue_buttons.check (MOUSEX, MOUSEY, event)) != -1) {

      switch (i) {
	case 0: /* Ok Button Was Pressed */
		  if (current_box == 1 || current_box == 0) { //Current list box is files
		    if (iswildcard(buffer)) {
		      strcpy (filter, buffer);
		      get_filelist(&file_box, filter);
		     }
		    else if (isdirectory(buffer)) { //Dir? change to it
		      if (getcwd (path, MAX_STRING_LENGTH) == NULL)
			error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");

		      buffer[0] = '\0';
		      redraw = TRUE;
		      get_filelist(&file_box, filter);
		     }
		    else  //Is a filename...load it
		      done = TRUE;
		   } //End of if in filename box
		  else if (current_box == 2) { //Current list box is drives
		    if (drive_box.get_name (&buffer[0])) {

			//Make sure there is a disk in the drive
		      check_disk(buffer[0] - 'A');
		      buffer[0] = '\0';
		      redraw = TRUE;
		      get_filelist(&file_box, filter);

		      if (getcwd (path, MAX_STRING_LENGTH) == NULL)
			error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");
		     }
		   } /* End of if in drives box */

		  break; /*End of 'ok' button pressed */
	case 1: /*  The Cancel button Pressed */
		  done = TRUE;
		  cancel = TRUE;
		  break;
       } /* End of switch which button pressed */
     } /*  End of if buttons pressed */
    else if (event == BUTTON_RELEASE && iscontained(MOUSEX, MOUSEY, filename_x, filename_y, filename_width, 1)) {

      current_box = 0;
      file_box.active = drive_box.active = FALSE;
      redraw = TRUE;
     }                 	/* Is the click in the filelist box */
    else if ((i = file_box.check (MOUSEX, MOUSEY, event)) != NO_ITEM && i != SCROLL_BAR) {
      if (current_box == 1 && file_box.current + i == double_click_item && clock() - double_click_time <= DOUBLE_CLICK_TIME) {
	do_double_click = TRUE;
	double_click_time = 0;
       }
      else {
	double_click_time = clock();
	double_click_item = file_box.current + i;
	do_double_click = FALSE;
       }

      current_box = 1;
      file_box.move (i);
      file_box.active = TRUE;
      drive_box.active = FALSE;
      redraw = TRUE;
     }               	/* Is the click in the drivelist box */
    else if ((i = drive_box.check (MOUSEX, MOUSEY, event)) != NO_ITEM && i != SCROLL_BAR) {
      if (current_box == 2 && drive_box.current + i == double_click_item && clock() - double_click_time <= DOUBLE_CLICK_TIME) {
	do_double_click = TRUE;
	double_click_time = 0;
       }
      else {
	double_click_time = clock();
	double_click_item = drive_box.current + i;
	do_double_click = FALSE;
       }

      current_box = 2;
      drive_box.move(i);
      file_box.active = FALSE;
      drive_box.active = TRUE;
      redraw = TRUE;
     }

	/* Get Keyboard Input */
    GetKey();

    if (current_box == 0) { /* Filename box */
      if (get_shift_key(SCAN_TAB)) { /* SHIFT-TAB */
	current_box = 2;
	drive_box.active = TRUE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (key_press[SCAN_TAB] != 0) { /* TAB */
	current_box++;
	file_box.active = TRUE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_esc_state()) { /* ESC */
	done = TRUE;
	cancel = TRUE;
       }
      else if (key_press[SCAN_BKSP] != 0 && strlen(buffer) > 0) { /* Backspace */
	buffer[strlen(buffer) - 1] = '\0';
	redraw = TRUE;
	delay (KEY_DELAY);
       }
      else if (get_enter_state()) { /* Enter */
	if (iswildcard(buffer)) {
	  get_filelist(&file_box, buffer);
	  strcpy (filter, buffer);
	  redraw = TRUE;
	 }
	else if (isdirectory(buffer)) { /* Dir? change to it */
	  if (getcwd (path, MAX_STRING_LENGTH) == NULL)
	    error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");

	  buffer[0] = '\0';
	  redraw = TRUE;

	  get_filelist(&file_box, filter);
	 }
	else  /* Is a filename...load it */
	  done = TRUE;

       }
      else if (isprint(keylast) && strlen(buffer) < 15 ) { /* Add character to end of string */
	chrcat(buffer, keylast);
	redraw = TRUE;
       }
     } /* End of in filename box */
    else if (current_box == 1) { /* Filelist box */
      if (get_shift_key (SCAN_TAB)) { /* SHIFT-TAB */
	current_box = 0;
	file_box.active = FALSE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (key_press[SCAN_TAB] != 0) { /* TAB */
	current_box = 2;
	file_box.active = FALSE;
	drive_box.active = TRUE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_enter_state() || do_double_click) { /* Enter */
	do_double_click = FALSE;

	if (file_box.get_name (&buffer[0])) {
	  if (isdirectory(buffer)) { /* Dir? change to it */
	    if (getcwd (path, MAX_STRING_LENGTH) == NULL)
	      error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");

	    buffer[0] = '\0';
	    redraw = TRUE;
	    file_box.current = 0;

	    get_filelist(&file_box, filter);
	   }
	  else /* File...load it */
	    done = TRUE;
	 }
       }
      else if (get_esc_state()) { /* ESC */
	done = TRUE;
	cancel = TRUE;
       }
      else if (get_up_state()) { /* Up */
	if (file_box.move(-1)) redraw = TRUE;
	delay (2*KEY_DELAY);
       } //End of if 'up'
      else if (get_down_state()) { /* Down */
	if (file_box.move(1)) redraw = TRUE;
	delay (2*KEY_DELAY);
       } //End of if 'down'
      else if (get_pgup_state()) { /* PgUp */
	if (file_box.move(-file_box.height)) redraw = TRUE;
	delay (2*KEY_DELAY);
       } //End of if 'pgup'
      else if (get_pgdn_state()) { /* PgDn */
	if (file_box.move(file_box.height)) redraw = TRUE;
	delay (2*KEY_DELAY);
       } //End of if 'pgdn'
      else if (get_home_state()) { /* Home */
	file_box.view = file_box.start;
	file_box.current = 0;
	redraw = TRUE;
	delay (KEY_DELAY);
       }
      else if (get_end_state()) { /* End */
	file_box.view = file_box.end;
	file_box.current = 0;
	redraw = TRUE;
	delay (KEY_DELAY);
       }
     } /* End of in filelist box */
    else if (current_box == 2) { /* Drive box */
      if (get_shift_key (SCAN_TAB)) { /* SHIFT-TAB */
	current_box = 1;
	drive_box.active = FALSE;
	file_box.active = TRUE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (key_press[SCAN_TAB]) { /* TAB */
	current_box = 0;
	drive_box.active = FALSE;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_enter_state() || do_double_click) { /* Enter */
	do_double_click = FALSE;

	if (drive_box.get_name(&buffer[0])) {
		/* Make sure there is a disk in the drive */
	  check_disk(buffer[0] - 'A');
	  buffer[0] = '\0';
	  redraw = TRUE;
	  get_filelist(&file_box, filter);

	  if (getcwd (path, MAX_STRING_LENGTH) == NULL)
	    error_box ("ERROR: Path too Long", "Path length cannot exceed 80 bytes!");
	 }
       } /* End of if 'ENTER' */
      else if (get_esc_state()) { /* ESC */
	done = TRUE;
	cancel = TRUE;
       }
      else if (get_up_state()) { //Up
	if (drive_box.move (-1)) redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_down_state()) { //Down
	if (drive_box.move (1)) redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_pgup_state()) { //PgUp
	if (drive_box.move (-drive_box.height)) redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_pgdn_state()) { //PgDn
	if (drive_box.move (drive_box.height)) redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_home_state()) { //Home
	drive_box.view = drive_box.start;
	drive_box.current = 0;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
      else if (get_end_state()) { //End
	drive_box.view = drive_box.end;
	drive_box.current = 0;
	redraw = TRUE;
	delay (2*KEY_DELAY);
       }
     } /* End of in drive_list box */
  } while(!done); /* End of main file-box loop */

  file_box.delete_list ();	/* Clear the filelist */
  drive_box.delete_list (); 	/* Clear the drivelist */

	/* Reset to original drive and directory */
  setdisk (orig_drive);
  chdir (orig_directory);

	/* Reset screen colors */
  textcolor (orig_text_color);
  textbackground (orig_back_color);

	/* Put back background */
  put_screen (&cap_text);

  dialogue_buttons.destroy();
  if (cancel) return(FALSE); /* Return a failure */
  _fstrcpy (filename, buffer);
  return (TRUE);
 }
/*========== End of function file_dialogue() ==============================*/


/*========== Gets the List of Available Drives ============================*/
boolean get_drivelist(LIST_BOX *drive_box) {
  unsigned int save_disk, count, num_drives;
  char buffer[81];

  _dos_getdrive(&save_disk); /* save original drive */
  _dos_setdrive (save_disk, &num_drives);

  for (count = 0; count < num_drives; count++) { /* get the drive letters available */
    setdisk(count);

    if (count == getdisk()) {
      buffer[0] = 0;
      chrcat(&buffer[0], count + 'A');
      chrcat(&buffer[0], ':');
      drive_box->add_end (buffer);
     }
   }

  _dos_setdrive(save_disk, &num_drives); //Set back to original drive
  drive_box->view = drive_box->start;
  return(TRUE);
 }
/*========== End of function get_drivelist ================================*/


/*========== Gets a directory listing =====================================*/
boolean get_filelist(LIST_BOX *file_box, const char far *filter) {
  struct ffblk file_block;
  char buffer[20];	/* Temp string buffer to hold directory name */
  int done;
  boolean prev_dir = FALSE;

	/* Clear the list */
  file_box->delete_list ();

	/* Get all required files, no directories */
  if (findfirst(filter, &file_block, 0) == 0) {

    do {	/* Keep getting names till none left */
      file_box->add_sort (file_block.ff_name);
      done = findnext(&file_block);
     } while (!done);
   }

	/* Find all the directories first */
  if (findfirst("*.*", &file_block, FA_DIREC) != 0) return(FALSE);

  do {	/* Keep getting names till none left, only add directories this time */
    if (file_block.ff_attrib == FA_DIREC) {
      if (file_block.ff_name[0] == '.') {
	if (file_block.ff_name[1] == '.') prev_dir = TRUE;
       }
      else {
	sprintf (&buffer[0], "%-12s<DIR>", file_block.ff_name);
	file_box->add_start (&buffer[0]);
       }

     }

    done = findnext(&file_block);
   } while (!done);

	/* Add a previous directory if there is any */
  if (prev_dir) file_box->add_start ("..          <DIR>");

  file_box->view = file_box->start;
  return(TRUE);
 }
/*========== End of function get_filelist() ===============================*/

