	/* Standard Includes */
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

	/* User defined includes */
#include "genutil.h"
#include "mouse.h"
#include "util.h"
#include "textfld.h"



/*========== Class TEXT_FIELD Constructor =================================*/
void TEXT_FIELD::TEXT_FIELD (void) {
  x = -1;
  y = -1;
  width = 0;
  title[0] = title[20] = 0;
  value[0] = value[20] = 0;
  title_text_color = YELLOW;
  title_back_color = BLUE;
  value_text_color = LIGHTGRAY;
  value_back_color = BLACK;
  number = 0;
 }
/*========== End Class TEXT_FIELD Constructor =============================*/


/*========== Returns TRUE if a MOUSE was Clicked on the Item ==============*/
boolean TEXT_FIELD::check (const int mx, const int my, const int event) {
  if (event != BUTTON_RELEASE) return (FALSE);

  if (my == y && mx >= x - strlen(title) - 1 && mx <= x + width + 1) {
    return(get_input (value, width, 24 + strlen(title) + 5, 8, "Input Value", "Enter a new value for %s", title) );
   }

  return (FALSE);
 }
/*========== End of function TEXT_FIELD::check() ==========================*/


/*========== Draws the Field on the Screen ================================*/
void TEXT_FIELD::draw (void) {
  int orig_attr = get_textattr();

  textcolor (value_text_color);
  textbackground (value_back_color);

  hide_mouse();
  gotoxy (x - 1, y);
  cprintf (" %-*s ", width - 2, value);
  show_mouse();

  textattr (orig_attr);
 }
/*========== End of procedure TEXT_FIELD::draw() ==========================*/


/*========== Draws the Field Title on the Screen ==========================*/
void TEXT_FIELD::draw_title (void) {
  int orig_attr = get_textattr();

  textcolor (title_text_color);
  textbackground (title_back_color);

  hide_mouse();
  gotoxy (x - strlen(title) - 2, y);
  cprintf ("%s",title);
  show_mouse();

  textattr (orig_attr);
 }
/*========== End of procedure TEXT_FIELD::draw_title() ====================*/


/*========== Class TEXT_ARRAY Constructor =================================*/
void TEXT_ARRAY::TEXT_ARRAY (void) {
  count = 0;
 }
/*========== End Class TEXT_ARRAY Constructor =============================*/


/*========== Adds an Item to the end of the Array...if any ================*/
int TEXT_ARRAY::add_text (const int x, const int y, const int width, const char *title) {
  if (count < MAX_TEXT_FIELDS) {
    fields[count].x = x;
    fields[count].y = y;
    fields[count].width = width;
    if (title) _fstrncpy (fields[count].title, title, 20);
    count++;
    return (count - 1);
   }
  else
    return (-1);
 }
/*========== End of function TEXT_ARRAY::add_text() =======================*/


/*========== Returns TRUE if a MOUSE was Clicked on the Item ==============*/
boolean TEXT_ARRAY::check (const int mx, const int my, const int event) {
  int i;	/* Loop counter */

  if (event != BUTTON_RELEASE) return (FALSE);

  for (i = 0; i < count; i++) {
    if (fields[i].check(mx, my, event)) return (TRUE);
   }

  return (FALSE);
 }
/*========== End of function TEXT_ARRAY::check() ==========================*/


/*========== Draws all the Fields on the Screen ===========================*/
void TEXT_ARRAY::draw (void) {
  int i;	/* Loop counter */

  for (i = 0; i < count; i++)
    fields[i].draw();

 }
/*========== End of procedure TEXT_ARRAY::draw() ==========================*/


/*========== Draws all the Field Titles on the Screen =====================*/
void TEXT_ARRAY::draw_titles (void) {
  int i;	/* Loop counter */

  for (i = 0; i < count; i++)
    fields[i].draw_title();

 }
/*========== End of procedure TEXT_ARRAY::draw_titles() ===================*/