	/* The array size for the TEXT_ARRAY Class */
#define MAX_TEXT_FIELDS 6



/*========== Define the Class TEXT_FIELD ==================================*/
	/* Text field is a class which operates a simple text field on the
	 * screen.  This field has a location, a title, and a displayed
	 * text value, and a long integer hidden value */
class TEXT_FIELD {

public:
  int x, y;	/* Location of Text Value */
  int width;	/* Width of text value field */
  int title_text_color, title_back_color;
  int value_text_color, value_back_color;
  char value[21];
  char title[21];
  unsigned long number;

	/* Class constructor */
  TEXT_FIELD (void);

	/* Returns TRUE if a MOUSE was Clicked on the Item */
  boolean check (const int mx, const int my, const int event);

	/* Draws a field */
  void draw (void);

	/* Draws the Field Title on the Screen */
  void draw_title (void);

};
/*========== End of class TEXT_FIELD Definition ===========================*/


/*========== Composes an Array of TEXT_FIELDS =============================*/
class TEXT_ARRAY {

public:

  TEXT_FIELD fields[MAX_TEXT_FIELDS];
  int count;	/* Number of current fields */

	/* Class Constructor */
  TEXT_ARRAY (void);

	/* Adds an Item to the end of the Array...if any */
  int add_text (const int x, const int y, const int width, const char *title = NULL);

	/* Returns TRUE if a MOUSE was Clicked on the Item */
  boolean check (const int mx, const int my, const int event);

	/* Draws all the Fields on the Screen */
  void draw (void);

	/* Draws all the Field Titles on the Screen */
  void draw_titles (void);
 };
/*========== End of Class TEXT_ARRAY Definition ===========================*/